package com.bofeng.wx.controller;


import com.bofeng.entity.MsReport;
import com.bofeng.entity.MsSuspected;
import com.bofeng.service.MsSuspectedService;
import com.bofeng.service.RiBaoService;
import com.yvan.Model;
import com.yvan.ModelOps;
import com.yvan.mvc.Pd;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RestController;

import javax.servlet.http.HttpServletRequest;
import java.math.BigDecimal;
import java.util.ArrayList;
import java.util.List;

/**
 * @Author: songjiaqing
 * @Date: 2020/2/4 15:38
 */
@RestController
public class RiBaoController {

    @Autowired
    private MsSuspectedService msSuspectedService;
    @Autowired
    private RiBaoService riBaoService;


    private String suspected_id;
    private String report_id;
    private String user_name;
    private String grender;
    private String age;
    private String family_status;
    private String status_desp;
    private String medical;
    private String temperature;
    private String cough;
    private String muscle;
    private String dyspnea;
    private String fatigue;
    private String diarrhea;
    private String single_room;
    private String suspected_status;
    private String others;
    private String user_create;
    private String time_create;
    private String user_update;
    private String time_update;


    //查询家人
    @GetMapping("/riBao/getRibao")
    public MsReport queryRibao(@Pd(name = "userCreate") Long userCreate) {
        Long reportId = riBaoService.getNowByYesterday(userCreate);
        MsReport msReport = riBaoService.selectById(reportId);
        String houseStr = riBaoService.getHouseStr(msReport.getHouseId());
        msReport.setHouseIdStr(houseStr);
        return msReport;
    }

    // 进入日报首页
    @GetMapping("/riBao/queryRibaoDetailList")
    public Model<List<MsSuspected>> queryRibaoDetailList(@Pd(name = "userCreate") Long userCreate) {
        Long reportId = riBaoService.getNowByYesterday(userCreate);
        List<MsSuspected> listSuspected = riBaoService.queryRibaoDetailList(reportId);
        return Model.newSuccess(listSuspected);
    }

    // 添加日报
    @GetMapping("/riBao/addOrEditRibao")
    public ModelOps addOrEditRibao(
            @Pd(name = "suspectedId") Long suspectedId,
            @Pd(name = "userName") String userName,// 家人姓名
            @Pd(name = "grender") Integer grender,// 性别:0未设置，1男,2女
            @Pd(name = "age") Integer age,// 年龄
            @Pd(name = "familyStatus") Integer familyStatus,// 基本状态:0正常，1心血管疾病（服用ARB）,2心血管疾病（未服用ARB）,3呼吸系统病史，4肿瘤病史，5糖尿病史，6服用过激素药物，7妊娠期，8其他
            @Pd(name = "statusDesp") String statusDesp,// 状态描述
            @Pd(name = "medical") Integer medical,// 是否确诊:0否,1是
            @Pd(name = "temperature") BigDecimal temperature,// 体温
            @Pd(name = "cough") Integer cough,// 咳嗽:0无咳嗽,1偶有短暂咳嗽，2咳嗽轻度影响生活，3咳嗽严重影响生活
            @Pd(name = "muscle") Integer muscle,// 肌肉酸痛:0无,1按压有，2偶尔，3持续有
            @Pd(name = "dyspnea") Integer dyspnea,// 呼吸困难:0无,1急走或上坡气短，2气短而走路变慢，3走路数分钟后气短，4气短无法离开房间
            @Pd(name = "fatigue") Integer fatigue,// 乏力:0无,1可体力劳动但觉得累，2轻体力劳动后长时间不能恢复，3不能正常生活
            @Pd(name = "diarrhea") Integer diarrhea,// 腹泻:0无,1轻度腹泻少于于3次，2中度腹泻4-6次，3重度腹泻超过6次
            @Pd(name = "singleRoom") Integer singleRoom,// 单间隔离:0否,1是
//            @Pd(name = "suspectedStatus") String suspectedStatus,// 是否疑似:0否,1是
            @Pd(name = "others") String others,// 其他
            @Pd(name = "userCreate") Long userCreate) {
        msSuspectedService.addSuspected(suspectedId, userName, grender, age, familyStatus, statusDesp, medical, temperature, cough, muscle, dyspnea, fatigue, diarrhea, singleRoom, others, userCreate);
        return ModelOps.newSuccess();
    }


    //查询家人
    @GetMapping("/riBao/selectSuspected")
    public MsSuspected selectSuspected(HttpServletRequest request) {
        //初始化今日日报
        Long suspectedId = Long.parseLong(request.getParameter("suspectedId"));
        return msSuspectedService.selectSuspected(suspectedId);
    }

    //删除家人病例
    @PostMapping("/riBao/deleteSuspected")
    public Integer deleteSuspected(HttpServletRequest request) {
        Long suspectedId = Long.parseLong(request.getParameter("suspectedId"));
        msSuspectedService.deleteSuspected(suspectedId);
        return 1;
    }

//    //根据登录人获取家人
//    @GetMapping("/riBao/queryRibao")
//    public Model<List<MsSuspected>> queryRibao(@Pd(name = "userCreate") Long userCreate) {
//        Date t = new Date();
//        SimpleDateFormat df = new SimpleDateFormat("yyyy-MM-dd");
//        String reportDate = df.format(t);
//        return Model.newSuccess(msReportService.getByReportReportDate(reportDate, userCreate));
//    }

    //根据日报获取家人
    @GetMapping("/riBao/queryRibaoRefresh")
    public Model<List<MsSuspected>> queryRibaoRefresh(@Pd(name = "reportId") Long reportId) {
        return Model.newSuccess(riBaoService.getByReportId(reportId));
    }

    //全家报平安
    @PostMapping("/riBao/addReport")
    public ModelOps addReport(HttpServletRequest request) {
        Long userCreate = Long.parseLong(request.getParameter("userCreate"));
        int re = riBaoService.addReport(userCreate);
        if (re == 1) {
            return ModelOps.newSuccess();
        } else if (re == 2) { //没有上报体温
            return ModelOps.newFail("请填报今日体温！");
        }
        return ModelOps.newFail("上报错误");
    }

    //根据日期获取家人
    @GetMapping("/riBao/queryRibaoReportDate")
    public Model<List<MsSuspected>> queryRibaoReportDate(
            @Pd(name = "reportDate") String reportDate,
            @Pd(name = "userCreate") Long userCreate) {
//        return Model.newSuccess(riBaoService.getByReportReportDate(reportDate, userCreate));
        return Model.newSuccess(new ArrayList<>());
    }

    //通过昨天数据更新今天数据
    @PostMapping("/riBao/getNowByYesterday")
    public Integer getNowByYesterday(HttpServletRequest request) {
        Long userCreate = Long.parseLong(request.getParameter("userCreate"));
        riBaoService.getNowByYesterday(userCreate);
        return 1;
    }
}
